Index: drivers/filesystems/btrfs/search.c
===================================================================
--- drivers/filesystems/btrfs/search.c	(révision 75772)
+++ drivers/filesystems/btrfs/search.c	(copie de travail)
@@ -683,11 +743,200 @@
 #endif
     DEVICE_INTERFACE_CHANGE_NOTIFICATION* dicn = (DEVICE_INTERFACE_CHANGE_NOTIFICATION*)NotificationStructure;
     PDRIVER_OBJECT DriverObject = (PDRIVER_OBJECT)Context;
-    
+
     if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_ARRIVAL, sizeof(GUID)) == sizeof(GUID))
-        disk_arrival(DriverObject, dicn->SymbolicLinkName);
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, disk_arrival);
     else if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_REMOVAL, sizeof(GUID)) == sizeof(GUID))
-        disk_removal(DriverObject, dicn->SymbolicLinkName);
-    
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, volume_removal);
+
     return STATUS_SUCCESS;
 }
+
+static void mountmgr_process_drive(PDEVICE_OBJECT mountmgr, PUNICODE_STRING device_name) {
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+    BOOL done = FALSE;
+
+    ExAcquireResourceSharedLite(&pdo_list_lock, TRUE);
+
+    le = pdo_list.Flink;
+    while (le != &pdo_list) {
+        pdo_device_extension* pdode = CONTAINING_RECORD(le, pdo_device_extension, list_entry);
+        LIST_ENTRY* le2;
+
+        ExAcquireResourceSharedLite(&pdode->child_lock, TRUE);
+
+        le2 = pdode->children.Flink;
+
+        while (le2 != &pdode->children) {
+            volume_child* vc = CONTAINING_RECORD(le2, volume_child, list_entry);
+
+            if (vc->devobj) {
+                MOUNTDEV_NAME mdn;
+
+                Status = dev_ioctl(vc->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+                if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
+                    ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                else {
+                    MOUNTDEV_NAME* mdn2;
+                    ULONG mdnsize = (ULONG)offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+
+                    mdn2 = ExAllocatePoolWithTag(NonPagedPool, mdnsize, ALLOC_TAG);
+                    if (!mdn2)
+                        ERR("out of memory\n");
+                    else {
+                        Status = dev_ioctl(vc->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+                        if (!NT_SUCCESS(Status))
+                            ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                        else {
+                            if (mdn2->NameLength == device_name->Length && RtlCompareMemory(mdn2->Name, device_name->Buffer, device_name->Length) == device_name->Length) {
+                                Status = remove_drive_letter(mountmgr, device_name);
+                                if (!NT_SUCCESS(Status))
+                                    ERR("remove_drive_letter returned %08x\n", Status);
+                                else
+                                    vc->had_drive_letter = TRUE;
+
+                                done = TRUE;
+                                break;
+                            }
+                        }
+
+                        ExFreePool(mdn2);
+                    }
+                }
+            }
+
+            le2 = le2->Flink;
+        }
+
+        ExReleaseResourceLite(&pdode->child_lock);
+
+        if (done)
+            break;
+
+        le = le->Flink;
+    }
+
+    ExReleaseResourceLite(&pdo_list_lock);
+}
+
+static void mountmgr_updated(PDEVICE_OBJECT mountmgr, MOUNTMGR_MOUNT_POINTS* mmps) {
+    ULONG i;
+
+    static WCHAR pref[] = L"\\DosDevices\\";
+
+    for (i = 0; i < mmps->NumberOfMountPoints; i++) {
+        UNICODE_STRING symlink, device_name;
+
+        if (mmps->MountPoints[i].SymbolicLinkNameOffset != 0) {
+            symlink.Buffer = (WCHAR*)(((UINT8*)mmps) + mmps->MountPoints[i].SymbolicLinkNameOffset);
+            symlink.Length = symlink.MaximumLength = mmps->MountPoints[i].SymbolicLinkNameLength;
+        } else {
+            symlink.Buffer = NULL;
+            symlink.Length = symlink.MaximumLength = 0;
+        }
+
+        if (mmps->MountPoints[i].DeviceNameOffset != 0) {
+            device_name.Buffer = (WCHAR*)(((UINT8*)mmps) + mmps->MountPoints[i].DeviceNameOffset);
+            device_name.Length = device_name.MaximumLength = mmps->MountPoints[i].DeviceNameLength;
+        } else {
+            device_name.Buffer = NULL;
+            device_name.Length = device_name.MaximumLength = 0;
+        }
+
+        if (symlink.Length > wcslen(pref) * sizeof(WCHAR) &&
+            RtlCompareMemory(symlink.Buffer, pref, wcslen(pref) * sizeof(WCHAR)) == wcslen(pref) * sizeof(WCHAR))
+            mountmgr_process_drive(mountmgr, &device_name);
+    }
+}
+
+_Function_class_(KSTART_ROUTINE)
+#ifdef __REACTOS__
+void NTAPI mountmgr_thread(_In_ void* context) {
+#else
+void mountmgr_thread(_In_ void* context) {
+#endif
+    UNICODE_STRING mmdevpath;
+    NTSTATUS Status;
+    PFILE_OBJECT FileObject;
+    PDEVICE_OBJECT mountmgr;
+    MOUNTMGR_CHANGE_NOTIFY_INFO mcni;
+
+    UNUSED(context);
+
+    RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+    Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        return;
+    }
+
+    mcni.EpicNumber = 0;
+
+    while (TRUE) {
+        PIRP Irp;
+        MOUNTMGR_MOUNT_POINT mmp;
+        MOUNTMGR_MOUNT_POINTS mmps;
+        IO_STATUS_BLOCK iosb;
+
+        KeClearEvent(&mountmgr_thread_event);
+
+        Irp = IoBuildDeviceIoControlRequest(IOCTL_MOUNTMGR_CHANGE_NOTIFY, mountmgr, &mcni, sizeof(MOUNTMGR_CHANGE_NOTIFY_INFO),
+                                            &mcni, sizeof(MOUNTMGR_CHANGE_NOTIFY_INFO), FALSE, &mountmgr_thread_event, &iosb);
+
+        if (!Irp) {
+            ERR("out of memory\n");
+            break;
+        }
+
+        Status = IoCallDriver(mountmgr, Irp);
+
+        if (Status == STATUS_PENDING) {
+            KeWaitForSingleObject(&mountmgr_thread_event, Executive, KernelMode, FALSE, NULL);
+            Status = iosb.Status;
+        }
+
+        if (shutting_down)
+            break;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("IOCTL_MOUNTMGR_CHANGE_NOTIFY returned %08x\n", Status);
+            break;
+        }
+
+        TRACE("mountmgr changed\n");
+
+        RtlZeroMemory(&mmp, sizeof(MOUNTMGR_MOUNT_POINT));
+
+        Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_QUERY_POINTS, &mmp, sizeof(MOUNTMGR_MOUNT_POINT), &mmps, sizeof(MOUNTMGR_MOUNT_POINTS),
+                           FALSE, NULL);
+
+        if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
+            ERR("IOCTL_MOUNTMGR_QUERY_POINTS 1 returned %08x\n", Status);
+
+        if (mmps.Size > 0) {
+            MOUNTMGR_MOUNT_POINTS* mmps2;
+
+            mmps2 = ExAllocatePoolWithTag(NonPagedPool, mmps.Size, ALLOC_TAG);
+            if (!mmps2) {
+                ERR("out of memory\n");
+                break;
+            }
+
+            Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_QUERY_POINTS, &mmp, sizeof(MOUNTMGR_MOUNT_POINTS), mmps2, mmps.Size,
+                               FALSE, NULL);
+            if (!NT_SUCCESS(Status))
+                ERR("IOCTL_MOUNTMGR_QUERY_POINTS returned %08x\n", Status);
+            else
+                mountmgr_updated(mountmgr, mmps2);
+
+            ExFreePool(mmps2);
+        }
+    }
+
+    ObDereferenceObject(FileObject);
+
+    mountmgr_thread_handle = NULL;
+
+    PsTerminateSystemThread(STATUS_SUCCESS);
+}
